using System;
using System.Collections;

namespace GrassValley.Mseries.AppServer
{
	delegate void MenuCallback();

	class Menu
	{
		private class MenuItem
		{
			public MenuCallback mc;
			public string text;
			
			public MenuItem(string Text, MenuCallback Mc)
			{
				mc = Mc;
				text = Text;
			}
		}
			
		private ArrayList m_Items = new ArrayList();
		
		public void Add(string text,MenuCallback mc)
		{
			m_Items.Add(new MenuItem(text,mc));
		}
		
		public void Show()
		{
			while ( true )
			{
				Console.WriteLine("");
				Console.WriteLine(" [ E] Exit");
				for(int i = 0;i<m_Items.Count;++i)
				{
					MenuItem mi = m_Items[i] as MenuItem;
					if (i < 9)
						Console.WriteLine(" [ {0}] {1}", i+1, mi.text);
					else
						Console.WriteLine(" [{0}] {1}", i+1, mi.text);
				}
				
				string option = Console.ReadLine();
				if ( option.Equals("E") || option.Equals("e") )
					break;

				int chosen = 0;
				try
				{
					chosen = Int32.Parse( option );
				}
				catch
				{
					Console.WriteLine("Invalid option.");
					continue;
				}
				
				if ( chosen > m_Items.Count || chosen < 1 )
				{
					Console.WriteLine("Invalid option.");
				}
				else
				{
					MenuItem mi = m_Items[chosen-1] as MenuItem;
					MenuCallback mc = mi.mc;
					mc();
				}
			}
		}
	}
}